@startuml
title 5 insertTag
actor Actor
participant "CatERingAppManager.kitchenJobManager:KitchenJobManager" as kjm
participant "kitchenJobManager.currentKitchenJob:KitchenJob" as kj
participant "tag:Tag" as tt
participant "tags: List<Tag>" as lt
participant "r: KitchenJobReceiver" as rec

Actor -> kjm++: insertTag(name)

alt currentKitchenJob == null 
    kjm -->> Actor: throw UseCaseLogicException
else
	opt !currentKitchenJob.hasTagName(name)
    	kjm -> kj++:addTag(name)
    	kj --> tt**: create(name)
    	tt++
    	tt -> tt: setName(name)
    	tt -->> kj--: tag
    
    	kj -> lt++:add(tag)
    	deactivate lt
    	kj -->> kjm: tag
    	deactivate kj
   
    	group for each r in receivers
    		kjm -> rec++:notifyTagAdded(currentKitchenJob,tag)
        	deactivate rec
    	end 
    
    	kjm -->> Actor: tag
    end
    
    kjm -->> Actor--: null
    
end
@enduml
